02/04/2017 08:02 PM - Madars

Status: Rejected Start date: 02/04/2017
Priority: Normal (Code 4) Due date:
Description

It could be possible to send queries to some XATMI server with standard UBF and receive responses from database. For example,
we could send:

EX_DB_QUERY ="select data1, data2, data3 from sometable where data4=:EX DB _COL1"
EX_DB_COL1="abc"

tpcall("SQLSRV"...)

on response we could get:

EX_DB_COL1=datat

EX_DB_COL2=data2

EX_DB_COL3=data3

EX_DB_RESULT=0 (succeed, or DB code/mapped)

The support for XA transactions will come out of the box.
The target driver could use java jdbc system. We could offer using standard dialect, for example

https://blog.jooqg.org/2013/09/09/crazy-translations-of-simple-sql-expressions-to-various-sql-dialects/ so that developer could use one
language for any of the databases.

Some kind of clustering also could be possible with making journal logs and pushing the changes to DBs later... (just idea).

History

#1 - 09/18/2017 11:51 AM - Madars

Then for this case we will need XA driver which will keep the transaction in ATMI context (maybe internal driver/switch symbol). Thus we can run
transaction in full multi-thread/go-routine mode and still be in global transactions. And the Java end will roll the transactions with JDBC.

#2 - 01/04/2018 10:37 AM - Madars
h

#3 - 04/19/2018 08:35 AM - Madars

Would have option for multiple database replication. One database would be primary, and second db would be replicated via journal files.
#4 - 04/27/2018 01:57 PM - Madars
- File Idbc.zip added

- File Idbc.jar added

http://Idbc.sourceforge.net/

#5 - 04/27/2018 02:00 PM - Madars
- File ldbc-doc.7z added
https://blog.jooq.org/2013/09/09/crazy-translations-of-simple-sql-expressions-to-various-sql-dialects/
https://docs.oracle.com/cd/B10501_01/java.920/a96654/xadistra.htm
http://ldbc.sourceforge.net/

http://Idbc.sourceforge.net/

#6 - 07/19/2018 08:08 AM - Madars
- Parent task set to #328

#7 - 09/19/2018 02:42 PM - Madars

select
fld1 as U_FLD1
fld2 as U_FLD2
where
id = :U_ID[1]

Thus when fetching the data, it will try to load the U_FLD1 field if not succeed, then load into column number SQL_COL1_NAME, SQL_COL1_DATA,
etc...

if field is NULL, then try to load into U_FLD1_IND, if not found then load into SQL_COL1_IND. Not sure only about how to properly escape the
variables, as JDBC by default uses ? for the variable substitutions.

maybe in case if in string ":U_ID"" is needed, then it can be escaped with ":U_ID™".

Or if compiled statements are used, maybe they needs to be transferred to "?", but the field uploading to java driver shall be done in this order.

#8 - 11/13/2018 11:59 AM - Madars
https://en.wikipedia.org/wiki/JDBC_driver

That would be Type 3 driver — Network-Protocol driver (middleware driver)

#9 - 11/16/2018 11:53 AM - Madars
Postgres ECPG could be used as C precompiler for Enduro/X SQL Gateway.

#10 - 12/03/2018 07:09 AM - Madars
- Parent task changed from #328 to #357

#11 - 03/07/2019 12:45 PM - Madars

Needs API for metadata of columns: https://docs.oracle.com/javase/7/docs/api/java/sql/ResultSetMetaData.html

Seems like for data results, we just need to indicate column label (selected one), data type (XATMI typed) and NULL indicator.

All other infos must be request via separate call, otherwise the transport will get very bulky.
http://ldbc.sourceforge.net/
https://en.wikipedia.org/wiki/JDBC_driver
https://docs.oracle.com/javase/7/docs/api/java/sql/ResultSetMetaData.html

#12 - 03/23/2021 02:26 PM - Madars
- Status changed from New to Rejected

- % Done changed from 0 to 100

Files

ldbc.jar 273 KB 04/27/2018 Madars

ldbc.zip 504 KB 04/27/2018 Madars

ldbc-doc.7z 26.4 KB 04/27/2018 Madars
